<?php
/**
 *
 *  Copyright (c) 2003-09  PHPWind.net. All rights reserved.
 *  Support : http://www.phpwind.net
 *  This software is the proprietary information of PHPWind.com.
 *
 */
file_exists('install.php') && ObHeader('install.php');
error_reporting(E_ERROR | E_PARSE);
set_magic_quotes_runtime(0);
function_exists('date_default_timezone_set') && date_default_timezone_set('Etc/GMT+0');

$defined_vars = get_defined_vars();
foreach ($defined_vars as $_key => $_value) {
	if (!in_array($_key,array('GLOBALS','_POST','_GET','_COOKIE','_SERVER','_FILES','wind_in'))) {
		${$_key} = '';
		unset(${$_key});
	}
}

$t_array = explode(' ',microtime());
$P_S_T	 = $t_array[0] + $t_array[1];
$timestamp = time();

define('R_P',getdirname(__FILE__));
define('D_P',R_P);
define('P_W','global');
!defined('SCR') && define('SCR','other');

require_once(R_P.'require/common.php');
require_once(R_P.'require/defend.php');
//open pw mode
$db_mode && $defaultMode = $db_mode;
$defaultMode = empty($db_mode) ? 'bbs' : $db_mode;
$M_domain = $pwServer['HTTP_HOST'];
($db_modedomain && $m = array_search($M_domain,$db_modedomain)) || $m = GetGP('m');
if ($m == 'bbs') {
	$db_mode = '';
} elseif (isset($db_modes[$m]) && $db_modes[$m]['ifopen']) {
	$db_mode = $m;
}

if (empty($db_mode) && in_array(SCR,array('cate')) && $db_modes['area']['ifopen']) $db_mode = 'area';
if (!empty($db_mode) && file_exists(R_P."mode/$db_mode/")) {
	define('M_P',R_P."mode/$db_mode/");
	$m = $db_mode;
	$M_P = M_P;
	$db_modepages = $db_modepages[$db_mode];
	$pwModeImg = "mode/$db_mode/images";
} else {
	$db_mode = '';
}

$dirstrpos = strpos($pwServer['PHP_SELF'],$db_dir);
if ($dirstrpos !== false) {
	$tmp = substr($pwServer['PHP_SELF'],0,$dirstrpos);
	$pwServer['PHP_SELF'] = "$tmp.php";
} else {
	$tmp = $pwServer['PHP_SELF'];
}
$REQUEST_URI = $pwServer['PHP_SELF'].'?'.$pwServer['QUERY_STRING'];

if (GetCookie('lastvisit')) {
	list($c_oltime,$lastvisit,$lastpath) = explode("\t",GetCookie('lastvisit'));
	($onbbstime=$timestamp-$lastvisit)<$db_onlinetime && $c_oltime+=$onbbstime;
} else {
	$lastvisit = $lastpath = '';
	$c_oltime = $onbbstime = 0;
	Cookie('lastvisit',$c_oltime."\t".$timestamp."\t".$REQUEST_URI);
}
$db_cvtime != 0 && $timestamp += $db_cvtime*60;

$db_debug && error_reporting(E_ALL ^ E_NOTICE);
$wind_version = '7.3 RC';
$db_olsize	  = 96;

!is_array($db_bbstitle) && $db_bbstitle = array('index' => $db_bbstitle,'other' => '');
$db_bbstitle['other'] && $db_bbsname .= ' '.$db_bbstitle[other];
$R_url = $db_bbsurl = Char_cv("http://".$pwServer['HTTP_HOST'].substr($tmp,0,strrpos($tmp,'/')));
defined('SIMPLE') && SIMPLE && $db_bbsurl = substr($db_bbsurl,0,-7);

InitGP(array('fid','tid'),'GP',2);
$db = $ftp = $credit = null;

require_once(D_P.'data/sql_config.php');
!is_array($manager) && $manager = array();
$newmanager = array();
foreach ($manager as $key => $value) {
	if (!empty($value) && !is_array($value)) {
		$newmanager[$key] = $value;
	}
}
$manager = $newmanager;
if ($database == 'mysqli' && Pwloaddl('mysqli') === false) {
	$database = 'mysql';
}
ObStart();//noizy

if ($db_http != 'N') {
	$imgpath = $db_http;
	if (D_P != R_P) {
		$R_url = substr($db_http,-1)=='/' ?  substr($db_http,0,-1) : $db_http;
		$R_url = substr($R_url,0,strrpos($R_url,'/'));
	}
} else {
	$imgpath = $db_picpath;
}
$attachpath = $db_attachurl != 'N' ? $db_attachurl : $db_attachname;
$imgdir		= R_P.$db_picpath;
$attachdir	= R_P.$db_attachname;
$pw_posts   = 'pw_posts';
$pw_tmsgs   = 'pw_tmsgs';
$runfc		= 'N';

list($winduid,$windpwd,$safecv) = explode("\t",addslashes(StrCode(GetCookie('winduser'),'DECODE')));

$loginhash = GetVerify($onlineip,$db_pptkey);
if ($db_pptifopen && $db_ppttype == 'client') {
	if (strpos($db_pptloginurl,'?') === false) {
		$db_pptloginurl .= '?';
	} elseif (substr($db_pptloginurl,-1) != '&') {
		$db_pptloginurl .= '&';
	}
	if (strpos($db_pptregurl,'?') === false) {
		$db_pptregurl .= '?';
	} elseif (substr($db_pptregurl,-1) != '&') {
		$db_pptregurl .= '&';
	}
	$urlencode	= rawurlencode($db_bbsurl);
	$loginurl	= "$db_pptserverurl/{$db_pptloginurl}forward=$urlencode";
	$loginouturl= "$db_pptserverurl/$db_pptloginouturl&forward=$urlencode&verify=$loginhash";
	$regurl		= "$db_pptserverurl/{$db_pptregurl}forward=$urlencode";
} else {
	$loginurl	= 'login.php';
	$loginouturl= "login.php?action=quit&verify=$loginhash";
	$regurl		= $db_registerfile;
}

$ol_offset = GetCookie('ol_offset');
$skinco	   = GetCookie('skinco');
if ($db_refreshtime && $REQUEST_URI == $lastpath && $onbbstime < $db_refreshtime) {
	!GetCookie('winduser') && $groupid = 'guest';
	$skin = $skinco ? $skinco : $db_defaultstyle;
	Showmsg('refresh_limit');
}
if (!$db_bbsifopen && !defined('CK')) {
	require_once(R_P.'require/bbsclose.php');
}

$H_url =& $db_wwwurl;
$B_url =& $db_bbsurl;
$t		= array('hours'=>gmdate('G',$timestamp+$db_timedf*3600));
$tdtime	= PwStrtoTime(get_date($timestamp,'Y-m-d'));
$montime = PwStrtoTime(get_date($timestamp,'Y-m').'-1');

if ($_COOKIE || $timestamp%3 == 0) {
	switch (SCR) {
		case 'thread': $lastpos = "F$fid";break;
		case 'read': $lastpos = "T$tid";break;
		case 'index': $lastpos = 'index';break;
		default: $lastpos = 'other';
	}
	if ($timestamp-$lastvisit>$db_onlinetime || $lastpos != GetCookie('lastpos')) {
		$runfc = 'Y';
		Cookie('lastpos',$lastpos);
	}
}
if (is_numeric($winduid) && strlen($windpwd)>=16) {
	$winddb	  = User_info();
	$winduid  = $winddb['uid'];
	$groupid  = $winddb['groupid'];
	$userrvrc = (int)($winddb['rvrc']/10);
	$windid	  = $winddb['username'];
	$_datefm  = $winddb['datefm'];
	$_timedf  = $winddb['timedf'];

	$credit_pop = $winddb['creditpop'];
	if ($credit_pop && $db_ifcredit) {//Credit Changes Tips
		require_once(R_P.'require/bbscode.php');
		$credit_pop = convert($credit_pop);
		$db->update("UPDATE pw_memberdata SET creditpop='' WHERE uid=".pwEscape($winduid));
	}

	list($winddb['style'],$ifcustomstyle) = explode('|',$winddb['style']);
	$skin	  = $winddb['style'] ? $winddb['style'] : $db_defaultstyle;
	list($winddb['onlineip']) = explode('|',$winddb['onlineip']);
	$groupid == '-1' && $groupid = $winddb['memberid'];
	$curvalue = $db_signcurtype == 'rvrc' ? $userrvrc : $winddb[$db_signcurtype];
	if (getstatus($winddb['userstatus'],10) && (!$winddb['starttime'] && $db_signmoney && strpos($db_signgroup,",$groupid,") !== false && $curvalue > $db_signmoney || $winddb['starttime'] && $winddb['starttime'] != $tdtime)) {
		require_once(R_P.'require/Signfunc.php');
		Signfunc($winddb['starttime'],$curvalue);
	}
	unset($curvalue);
} else {
	$skin	 = $db_defaultstyle;
	$groupid = 'guest';
	$winddb  = $windid = $winduid = $_datefm = $_timedf = '';
}
$verifyhash = GetVerify($winduid);

if ($db_bbsifopen==2 && SCR!='login' && !defined('CK')) {
	require_once(R_P.'require/bbsclose.php');
}
if ($db_ifsafecv && strpos($db_safegroup,",$groupid,") !== false && !$safecv && !defined('PRO')) {
	Showmsg('safecv_prompt');
}
if ($db_ads && !$windid && (is_numeric($_GET['u']) || ($_GET['a'] && strlen($_GET['a'])<16)) && strpos($pwServer['HTTP_REFERER'],$pwServer['HTTP_HOST'])===false) {
	InitGP(array('u','a'));
	Cookie('userads',"$u\t$a\t".md5($pwServer['HTTP_REFERER']));
} elseif (GetCookie('userads') && $db_ads=='1') {
	list($u,$a) = explode("\t",GetCookie('userads'));
	if ((int)$u>0 || ($a && strlen($a)<16)) {
		require_once(R_P.'require/userads.php');
	}
}

if ($_POST['skinco']) {
	$skinco = $_POST['skinco'];
} elseif ($_GET['skinco']) {
	$skinco = $_GET['skinco'];
}
if ($skinco && file_exists(D_P."data/style/$skinco.php") && strpos($skinco,'..')===false) {
	$skin = $skinco;
	Cookie('skinco',$skin);
}

if ($db_columns && !defined('W_P') && !defined('SIMPLE') && !defined('COL')) {
	$j_columns = GetCookie('columns');
	if (!$j_columns) {
		$db_columns==2 && $j_columns = 2;
		Cookie('columns',$j_columns);
	}
	if ($j_columns==2 && (strpos($pwServer['HTTP_REFERER'],$db_bbsurl)===false || strpos($pwServer['HTTP_REFERER'],$db_adminfile)!==false)) {
		strpos($REQUEST_URI,'index.php')===false ? Cookie('columns','1') : ObHeader('columns.php?action=columns');
	}
}
Ipban();
Cookie('lastvisit',$c_oltime."\t".$timestamp."\t".$REQUEST_URI);

if ($groupid == 'guest' && $db_guestdir && GetGcache()) {
	require_once(R_P.'require/guestfunc.php');
	getguestcache();
}
PwNewDB();

unset($_key,$_value,$defined_vars,$t_array,$db_whybbsclose,$db_whycmsclose,$db_ipban,$db_diy,$dbhost,$dbuser,$dbpw,$dbname,$pconnect,$manager_pwd,$newmanager);

if ($groupid == 'guest') {
	require_once(D_P.'data/groupdb/group_2.php');
} elseif (file_exists(D_P."data/groupdb/group_$groupid.php")) {
	require_once Pcv(D_P."data/groupdb/group_$groupid.php");
} else {
	require_once(D_P.'data/groupdb/group_1.php');
}

if ($_G['pwdlimitime'] && !CkInArray($windid,$manager) && $timestamp-86400*$_G['pwdlimitime']>$winddb['pwdctime'] && !defined('PRO')) {
	Showmsg('pwdchange_prompt');
}

$SCR = SCR;
$header_ad = $footer_ad = '';

if (SCR != 'read') {
	$advertdb = AdvertInit(SCR,$fid);
	if (is_array($advertdb['header'])) {
		$header_ad = $advertdb['header'][array_rand($advertdb['header'])]['code'];
	}
	if (is_array($advertdb['footer'])) {
		$footer_ad = $advertdb['footer'][array_rand($advertdb['footer'])]['code'] .'<br />';
	}
	unset($advertdb['header'],$advertdb['footer']);
}

function refreshto($URL,$content,$statime=1){
	if (defined('AJAX')) Showmsg($content);
	global $db_ifjump;
	$URL = str_replace('&#61;','=',$URL);
	if ($db_ifjump && $statime>0) {
		ob_end_clean();
		global $expires,$db_charset,$tplpath,$fid,$imgpath,$db_obstart,$db_bbsname,$skin,$B_url,$forumname,$tpctitle,$bgcolor,$cbgfont,$linkcolor,$tdcolor,$forumcolortwo;
		$index_name =& $db_bbsname;
		$index_url =& $B_url;
		ObStart();//noizy
		if (file_exists(D_P."data/style/$skin.php") && strpos($skin,'..')===false) {
			include_once Pcv(D_P."data/style/$skin.php");
		} else {
			include_once(D_P.'data/style/wind.php');
		}
		$content = getLangInfo('refreshto',$content);
		@require PrintEot('refreshto');exit;
	} else {
		ObHeader($URL);
	}
}
function ObHeader($URL){
	global $db_obstart,$db_bbsurl,$db_htmifopen;
	if ($db_htmifopen && strncasecmp($URL,'http',4) != 0) {
		$URL = "$db_bbsurl/$URL";
	}
	ob_end_clean();
	if (!$db_obstart) {
		ob_start();
		echo "<meta http-equiv='refresh' content='0;url=$URL'>";exit;
	}
	header("Location: $URL");exit;
}
function Showmsg($msg_info,$dejump=0){
	@extract($GLOBALS, EXTR_SKIP);
	global $stylepath,$tablewidth,$mtablewidth,$tplpath,$db;
	$msg_info = getLangInfo('msg',$msg_info);
	if (defined('AJAX')) {
		echo $msg_info;ajax_footer();
	}
	$showlogin = false;
	if ($dejump!='1' && $groupid=='guest' && $REQUEST_URI==str_replace(array('register','login'),'',$REQUEST_URI) && (!$db_pptifopen || $db_ppttype != 'client')) {
		if (strpos($REQUEST_URI,'post.php')!==false) {
			$tmpTid = (int)GetGP('tid','P');
			$tmpTid && $REQUEST_URI = substr($REQUEST_URI,0,strrpos($REQUEST_URI,'/'))."/read.php?tid=$tmpTid&toread=1";
		}
		if ($db_htmifopen) {
			$REQUEST_URI = str_replace(array('.php?','&','='),array($db_dir,'-','-'),$REQUEST_URI);
			strpos($REQUEST_URI,$db_ext)===false && $REQUEST_URI .= $db_ext;
		}
		$jumpurl = "http://".$pwServer['HTTP_HOST'].$REQUEST_URI;
		list(,$qcheck)=explode("\t",$db_qcheck);
		$qkey = $qcheck && $db_question ? array_rand($db_question) : '';
		$showlogin = true;
	}
	define('MSG',1);
	$subject = strip_tags($msg_info).' - ';
	require_once(R_P.'require/header.php');
	require_once PrintEot('showmsg');exit;
}
function GetLang($lang,$EXT='php'){
	global $tplpath;
	
	if (file_exists(R_P."template/$tplpath/lang_$lang.$EXT")) {
		return R_P."template/$tplpath/lang_$lang.$EXT";
	} elseif (file_exists(R_P."template/wind/lang_$lang.$EXT")) {
		return R_P."template/wind/lang_$lang.$EXT";
	} else {
		exit("Can not find lang_$lang.$EXT file");
	}
}
function PrintEot($template,$EXT='htm'){
	//Copyright (c) 2003-09 PHPWind
	global $tplpath,$db_mode,$db_modes,$pwModeImg;
	!$template && $template = 'N';
	
	if (defined('M_P') && $db_mode && file_exists(M_P."template/$template.$EXT")) {
		return modeEot($template,$EXT);
	} elseif (file_exists(R_P."template/$tplpath/$template.$EXT")) {
		return R_P."template/$tplpath/$template.$EXT";
	} elseif (file_exists(R_P."template/wind/$template.$EXT")) {
		return R_P."template/wind/$template.$EXT";
	} else {
		exit("Can not find $template.$EXT file");
	}
}

function Ipban(){
	global $db_ipban;
	if ($db_ipban) {
		global $onlineip,$imgpath,$stylepath;
		$baniparray = explode(',',$db_ipban);
		foreach ($baniparray as $banip) {
			if ($banip && strpos(",$onlineip.",','.trim($banip).'.')!==false) {
				Showmsg('ip_ban');
			}
		}
	}
}
function Update_ol(){
	global $runfc,$db_online;
	if ($runfc == 'Y') {
		if ($db_online) {
			Sql_ol();
		} else {
			Txt_ol();
		}
		$runfc = 'N';
	}
}
function Txt_ol(){
	global $ol_offset,$winduid,$db_ipstates,$isModify;
	require_once(R_P.'require/userglobal.php');
	if ($winduid>0) {
		list($alt_offset,$isModify) = addonlinefile($ol_offset,$winduid);
	} else {
		list($alt_offset,$isModify) = addguestfile($ol_offset);
	}
	$alt_offset!=$ol_offset && Cookie('ol_offset',$alt_offset);
	$ipscookie = GetCookie('ipstate');
	if ($db_ipstates && ((!$ipscookie && $isModify===1) || ($ipscookie && $ipscookie<$GLOBALS['tdtime']))) {
		require_once(R_P.'require/ipstates.php');
	}
}
function Sql_ol(){
	global $db,$fid,$tid,$timestamp,$windid,$winduid,$onlineip,$groupid,$wind_in,$db_onlinetime,$db_ipstates,$db_today,$lastvisit;
	$olid	= (int)GetCookie('olid');
	$ifhide = $GLOBALS['_G']['allowhide'] && GetCookie('hideid') ? 1 : 0;
	$isModify = 0;
	PwNewDB();
	if ($olid) {
		$sqladd = $winduid ? '(uid='.pwEscape($winduid).' OR olid='.pwEscape($olid).' AND uid=0 AND ip='.pwEscape($onlineip).')' : 'olid='.pwEscape($olid).' AND ip='.pwEscape($onlineip);
		$pwSQL = pwSqlSingle(array(
			'username'	=> $windid,
			'lastvisit'	=> $timestamp,
			'fid'		=> $fid,
			'tid'		=> $tid,
			'groupid'	=> $groupid,
			'action'	=> $wind_in,
			'ifhide'	=> $ifhide,
			'uid'		=> $winduid,
			'ip'		=> $onlineip
		));
		$db->update("UPDATE pw_online SET $pwSQL WHERE $sqladd");
		if ($winduid && $db->affected_rows() > 1) {
			$db->update('DELETE FROM pw_online WHERE uid='.pwEscape($winduid).' AND olid!='.pwEscape($olid));
		}
	} elseif (!$_COOKIE) {
		$pwSQL = pwSqlSingle(array(
			'username'	=> $windid,
			'lastvisit'	=> $timestamp,
			'fid'		=> $fid,
			'tid'		=> $tid,
			'groupid'	=> $groupid,
			'action'	=> $wind_in,
			'ifhide'	=> $ifhide,
			'uid'		=> $winduid
		));
		$db->update("UPDATE pw_online SET $pwSQL WHERE ip=".pwEscape($onlineip));
	}
	if (!$olid && $_COOKIE || $db->affected_rows()==0) {
		$db->update('DELETE FROM pw_online WHERE uid!=0 AND uid='.pwEscape($winduid).' OR lastvisit<'.pwEscape($timestamp-$db_onlinetime));
		$rt = $db->get_one("SELECT MAX(olid) FROM pw_online",MYSQL_NUM);
		$olid = $rt[0]+1;
		$pwSQL = pwSqlSingle(array(
			'olid'		=> $olid,
			'username'	=> $windid,
			'lastvisit'	=> $timestamp,
			'ip'		=> $onlineip,
			'fid'		=> $fid,
			'tid'		=> $tid,
			'groupid'	=> $groupid,
			'action'	=> $wind_in,
			'ifhide'	=> $ifhide,
			'uid'		=> $winduid
		));
		$db->update("REPLACE INTO pw_online SET $pwSQL");
		Cookie('olid',$olid);
		$isModify = 1;
	}
	$ipscookie = GetCookie('ipstate');
	if ($db_ipstates && ((!$ipscookie && $isModify===1) || ($ipscookie && $ipscookie<$GLOBALS['tdtime']))) {
		require_once(R_P.'require/ipstates.php');
	}
	if ($db_today && $timestamp-$lastvisit>$db_onlinetime) {
		require_once(R_P.'require/today.php');
	}
}
function footer($flag = 1) {
	global $db,$db_obstart,$db_footertime,$db_htmifopen,$P_S_T,$mtablewidth,$db_ceoconnect,$wind_version,$imgpath, $stylepath,$footer_ad,$db_union,$timestamp,$db_icp,$db_icpurl,$advertdb,$groupid,$SCR,$ceversion,$db_ystats_ifopen,$db_ystats_unit_id,$db_ystats_style,$db_redundancy,$pwServer,$db_ifcredit,$credit_pop,$db_foot,$db_modes,$shortcutforum,$_G,$winddb;
	defined('AJAX') && ajax_footer();
	Update_ol();
	$wind_spend	= '';
	$ft_gzip = ($db_obstart ? 'Gzip enabled' : 'Gzip disabled').$db_union[3];
	if ($db_footertime == 1){
		$t_array	= explode(' ',microtime());
		$totaltime	= number_format(($t_array[0]+$t_array[1]-$P_S_T),6);
		$qn = $db ? $db->query_num : 0;
		$wind_spend	= "Total $totaltime(s) query $qn,";
		
	}
	$ft_time = get_date($timestamp,'m-d H:i');
	$db_icp && $db_icp = "<a href=\"http://www.miibeian.gov.cn\" target=\"_blank\">$db_icp</a>";
	if ($flag) {
		require PrintEot('footer');
		if ($advertdb['float'] || $advertdb['popup'] || $advertdb['leftfloat'] || $advertdb['rightfloat']) {
			require PrintEot('advert');
		}
	}
	$output = ob_get_contents();
	if ($db_htmifopen) {
		$output = preg_replace(
			"/\<a(\s*[^\>]+\s*)href\=([\"|\']?)(?!(http|ftp|telnet|mms|rtsp|rss|" . $GLOBALS['db_adminfile'] . "))([^\"\'>\s]+\.php\?[^\"\'>\s]+\s?)[\"|\']?/ies",
			"Htm_cv('\\4','<a\\1href=\"')",
			$output
		);
	}
	if ($db_redundancy && $SCR!='post') {
		$output = str_replace(
			array("\r","\n\n","\n\t","\n ",">\n","\n<","}\n","{\n",";\n","/\n","\t ",">\t","\t<","}\t","{\t",";\t","/\t",'  ','<!--<!---->','<!---->',substr(R_P,0,-1)),
			array('',"\n",' ',' ','>','<','}','{',';','/',' ','>','<','}','{',';','/',' ','','',''),
			$output
		);
	} else {
		$output = str_replace(array('<!--<!---->','<!---->',substr(R_P,0,-1)),'',$output);
	}
	if ($SCR!='post') {
		$output .= "<script language=\"JavaScript\" src=\"http://init.phpwind.net/init.php?sitehash={$GLOBALS[db_sitehash]}&v=$wind_version&c=$ceversion\"></script>";
	}
	if ($groupid == 'guest' && !defined('MSG') && GetGcache()) {
		require_once(R_P.'require/guestfunc.php');
		creatguestcache($output);
	}
	echo ObContents($output);
	unset($output);
	exit;
}
function Htm_cv($url,$tag){
	global $db_dir,$db_ext;
	$tmppos = strpos($url,'#');
	$add = $tmppos!==false ? substr($url,$tmppos) : '';
	$url = str_replace(
		array('.php?','=','&amp;','&',$add),
		array($db_dir,'-','-','-',''),
		$url
	).$db_ext.$add;
	return stripslashes($tag).$url.'"';
}
function User_info(){
	global $db,$timestamp,$db_onlinetime,$winduid,$windpwd,$safecv,$db_ifonlinetime,$c_oltime,$onlineip,$db_ipcheck,$tdtime,$montime,$db_ifsafecv,$db_ifpwcache;
	$ct = $sqladd = $sqltab = '';
	PwNewDB();
	if (in_array(SCR,array('index','read','thread','post'))) {
		$sqladd = SCR=='post' ? ',md.postcheck,sr.visit,sr.post,sr.reply' : ',sr.visit';
		$sqltab = "LEFT JOIN pw_singleright sr ON m.uid=sr.uid";
	}
	$detail = $db->get_one("SELECT m.uid,m.username,m.password,m.safecv,m.email,m.oicq,m.groupid,m.memberid,m.groups,m.icon,m.regdate,m.honor,m.timedf,m.style,m.datefm,m.t_num,m.p_num,m.yz,m.newpm,m.userstatus,m.shortcut,md.postnum,md.rvrc,md.money,md.credit,md.currency,md.lastvisit,md.thisvisit,md.onlinetime,md.lastpost,md.todaypost,md.monthpost,md.onlineip,md.uploadtime,md.uploadnum,md.starttime,md.pwdctime,md.monoltime,md.digests,md.f_num,md.creditpop $sqladd FROM pw_members m LEFT JOIN pw_memberdata md ON m.uid=md.uid $sqltab WHERE m.uid=".pwEscape($winduid));

	$loginout = 'N';
	if ($db_ipcheck && strpos($detail['onlineip'],$onlineip)===false) {
		$iparray = explode('.',$onlineip);
		strpos($detail['onlineip'],$iparray[0].'.'.$iparray[1])===false && $loginout = 'Y';
	}
	if (!$detail || PwdCode($detail['password'])!=$windpwd || $db_ifsafecv && $safecv!=$detail['safecv'] || $loginout=='Y') {
		unset($detail);
		$GLOBALS['groupid'] = 'guest';
		require_once(R_P.'require/checkpass.php');
		Loginout();
		Showmsg('ip_change');
	} else {
		unset($detail['password']);
		$detail['honor'] = substrs($detail['honor'],90);
		$distime = $timestamp - $detail['lastvisit'];
		if ($distime>$db_onlinetime || $distime>3600) {
			//Start elementupdate
			if ($db_ifpwcache & 1 && SCR!='post' && SCR!='thread') {
				require_once(R_P.'require/elementupdate.class.php');
				$elementupdate = new ElementUpdate();
				$elementupdate->userSortUpdate($detail);
			}
			//End elementupdate
			if (!GetCookie('hideid')) {
				$ecpvisit = pwEscape($timestamp);
				$ct = 'lastvisit='.$ecpvisit.',thisvisit='.$ecpvisit;
				if ($db_ifonlinetime) {
					$c_oltime = pwEscape(($c_oltime <= 0 ? 0 : ($c_oltime > $db_onlinetime*1.2 ? $db_onlinetime : intval($c_oltime))),false);
					$ct .= ',onlinetime=onlinetime+'.$c_oltime;
					if ($detail['lastvisit'] > $montime) {
						$ct .= ',monoltime=monoltime+'.$c_oltime;
					} else {
						$ct .= ',monoltime='.$c_oltime;
					}
					$c_oltime = 0;
				}
				$db->update("UPDATE pw_memberdata SET $ct WHERE uid=".pwEscape($winduid));
				$detail['lastvisit'] = $detail['thisvisit'] = $timestamp;
			}
		}
	}
	return $detail;
}
function AdvertInit($SCR,$fid){
	global $timestamp,$db_advertdb,$db_txtadnum;
	!(int)$db_txtadnum && $db_txtadnum=4;
	$newadvert = array();
	foreach ($db_advertdb as $key => $value) {
		foreach ($value as $v) {
			if ($v['starttime']<=$timestamp && $v['endtime']>=$timestamp) {
				if ($SCR=='index' && strpos(",$v[fid],",",-1,")!==false) {
					$newadvert[$key][] = $v;
				} elseif ($SCR=='thread' && strpos(",$v[fid],",",-2,")!==false) {
					$newadvert[$key][] = $v;
				} elseif ($SCR=='read' && strpos(",$v[fid],",",-3,")!==false) {
					$newadvert[$key][] = $v;
				} elseif (strpos(",$v[fid],",",-4,")!==false) {
					$newadvert[$key][] = $v;
				} elseif ($fid && strpos(",$v[fid],",",$fid,")!==false) {
					$newadvert[$key][] = $v;
				}
			}
		}
	}
	return $newadvert;
}
function readad($ads,$lou,$p){
	if (!$ads || !is_array($ads) || !$lou) return false;
	shuffle($ads);
	foreach ($ads as $value) {
		if ($value['position']==$p && (strpos(",$value[lou],",',-1,')!==false || strpos(",$value[lou],",",$lou,")!==false)) {
			return $value['code'];
		}
	}
	return false;
}
function admincheck($forumadmin,$fupadmin,$username){
	if (!$username) {
		return false;
	}
	if ($forumadmin && strpos($forumadmin,",$username,")!==false) {
		return true;
	}
	if ($fupadmin && strpos($fupadmin,",$username,")!==false) {
		return true;
	}
	return false;
}
function getdirname($path=null){
	if (!empty($path)) {
		if (strpos($path,'\\')!==false) {
			return substr($path,0,strrpos($path,'\\')).'/';
		} elseif (strpos($path,'/')!==false) {
			return substr($path,0,strrpos($path,'/')).'/';
		}
	}
	return './';
}
function allowcheck($allowgroup,$groupid,$groups,$fid='',$allowforum=''){
	if ($allowgroup && strpos($allowgroup,",$groupid,")!==false) {
		return true;
	}
	if ($allowgroup && $groups) {
		$groupids = explode(',',substr($groups,1,-1));
		foreach ($groupids as $value) {
			if (strpos($allowgroup,",$value,")!==false) {
				return true;
			}
		}
	}
	if ($fid && $allowforum && strpos(",$allowforum,",",$fid,")!==false) {
		return true;
	}
	return false;
}
function GetGcache() {
	global $db_fguestnum,$db_tguestnum,$db_guestindex;
	$page = isset($GLOBALS['page']) ? $GLOBALS['page'] : (int)$_GET['page'];
	if (SCR == 'thread' && $page < $db_fguestnum && !isset($_GET['type']) && !GetGP('search')) {
		return true;
	} elseif (SCR == 'read' && $page < $db_tguestnum && !isset($_GET['uid'])) {
		return true;
	} elseif (SCR == 'index' && $db_guestindex && !isset($_GET['cateid'])) {
		return true;
	}
	return false;
}
function GetVerify($str,$app = null) {
	empty($app) && $app = $GLOBALS['db_siteid'];
	return substr(md5($str.$app.$GLOBALS['pwServer']['HTTP_USER_AGENT']),8,8);
}
function PostCheck($verify = 1,$gdcheck = 0,$qcheck = 0,$refer = 1) {
	global $pwServer;
	$verify && checkVerify();
	if ($refer && $pwServer['REQUEST_METHOD'] == 'POST') {
		$referer_a = @parse_url($pwServer['HTTP_REFERER']);
		if ($referer_a['host']) {
			list($http_host) = explode(':',$pwServer['HTTP_HOST']);
			if ($referer_a['host'] != $http_host) {
				Showmsg('undefined_action');
			}
		}
	}
	$gdcheck && GdConfirm($_POST['gdcode']);
	$qcheck && Qcheck($_POST['qanswer'],$_POST['qkey']);
}
function checkVerify($hash = 'verifyhash') {
	GetGP('verify') <> $GLOBALS[$hash] && Showmsg('illegal_request');
}
function GdConfirm($code) {
	Cookie('cknum','',0);
	if (!$code || !SafeCheck(explode("\t",StrCode(GetCookie('cknum'),'DECODE')),strtoupper($code),'cknum',1800)) {
		Showmsg('check_error');
	}
}
function Qcheck($answer,$qkey) {
	global $db_question,$db_answer;
	if ($db_question && (!isset($db_answer[$qkey]) || $answer!=$db_answer[$qkey])) {
		Showmsg('qcheck_error');
	}
}
function PwNewDB() {
	if (!is_object($GLOBALS['db'])) {
		global $db,$database,$dbhost,$dbuser,$dbpw,$dbname,$pconnect;
		require_once Pcv(R_P."require/db_$database.php");
		$db = new DB($dbhost,$dbuser,$dbpw,$dbname,$pconnect);
	}
}
function Pwloaddl($mod,$ckfunc='mysqli_get_client_info') {
	return extension_loaded($mod) && $ckfunc && function_exists($ckfunc) ? true : false;
}
function setstatus(&$status,$b,$setv = '1') {
	--$b;
	for ($i = strlen($setv)-1; $i >= 0 ; $i--) {
		if ($setv[$i]) {
			$status |= 1 << $b;
		} else {
			$status &= ~(1 << $b);
		}
		++$b;
	}
	//return $status;
}
function sendHeader($num,$rtarr=null){
	static $sapi = null;
	if ($sapi===null) {
		$sapi = php_sapi_name();
	}
	$header_a = array(
		'200' => 'OK',
		'206' => 'Partial Content',
		'304' => 'Not Modified',
		'404' => '404 Not Found',
		'416' => 'Requested Range Not Satisfiable',
	);
	if ($header_a[$num]) {
		if ($sapi=='cgi' || $sapi=='cgi-fcgi') {
			$headermsg = "Status: $num ".$header_a[$num];
		} else {
			$headermsg = "HTTP/1.1: $num ".$header_a[$num];
		}
		if (empty($rtarr)) {
			header($headermsg);
		} else {
			return $headermsg;
		}
	}
	return;
}
/**
 * 添加会员最新动作
 *
 * @param int $uid		动作会员UID
 * @param string $type	动作类型
 * @param mixed $log	动作描述
 */
function pwAddFeed($uid,$type,$typeid,$log) {
	global $db,$timestamp;
	if (is_array($log)) {
		empty($log['lang']) && $log['lang'] = $type;
		$descrip = Char_cv(getLangInfo('feed',$log['lang'],$log));
	} else {
		$descrip = Char_cv($log);
	}
	$typeid = (int)$typeid;
	$db->update("INSERT INTO pw_feed SET " . pwSqlSingle(array(
		'uid'		=> $uid,
		'type'		=> $type,
		'typeid'	=> $typeid,
		'descrip'	=> $descrip,
		'timestamp'	=> $timestamp
	),false));
}
function getLastDate($time){
	global $timestamp,$tdtime;
	$decrease = $timestamp-$time;
	$thistime = PwStrtoTime(get_date($time,'Y-m-d'));
	$result = get_date($time);
	if ($thistime == $tdtime) {
		if ($decrease <= 3600) {
			return array(ceil($decrease/60),'minute',$result);
		} else {
			return array(ceil($decrease/3600),'hour',$result);
		}
	} elseif ($thistime == $tdtime-86400) {
		return array('','yesterday',$result);
	} elseif ($thistime == $tdtime-86400*2) {
		return array('','qiantian',$result);
	} elseif ($decrease <= 7776000) {
		return array(ceil($decrease/86400),'day',$result);
	} else {
		return array($result,false,$result);
	}
}
function procLock($t, $u = 0) {
	global $db,$timestamp;
	if ($db->query("INSERT INTO pw_proclock (uid,action,time) VALUES ('$u','$t','$timestamp')",'U',false)) {
		return true;
	}
	$db->update("DELETE FROM pw_proclock WHERE uid='$u' AND action='$t' AND time < '$timestamp' - 30");
	return false;
}
function procUnLock($t = '', $u = 0) {
	$GLOBALS['db']->update("DELETE FROM pw_proclock WHERE uid='$u' AND action='$t'");
}
?>